init offset = -501

screen value_input(message, ok_action, alloww):
    modal True
    zorder 200
    add "gui/overlay/confirm.png"
    key "K_RETURN" action ok_action
    frame:
        background Frame([ "gui/confirm_frame.png", "gui/frame.png"], gui.confirm_frame_borders, tile=gui.frame_tile)
        padding gui.confirm_frame_borders.padding
        xalign .5
        yalign .5
        has vbox:
            xalign .5
            yalign .5
            spacing 30
        label _(message):
            style "gui_prompt"
            xalign 0.5
        input default "" value VariableInputValue("value") length 18 allow alloww color "#ff16d8" outlines [] text_align 0.5 layout "subtitle"
        hbox:
            xalign 0.5
            spacing 100
            textbutton _("OK") action ok_action

screen dialog(message, ok_action=Hide("dialog"), ok_text="OK"):
    modal True
    zorder 300
    add "gui/overlay/confirm.png"
    frame:
        background Frame([ "gui/confirm_frame.png", "gui/frame.png"], gui.confirm_frame_borders, tile=gui.frame_tile)
        padding gui.confirm_frame_borders.padding
        xalign .5
        yalign .5
        has vbox:
            xalign .5
            yalign .5
            spacing 30
        label _(message):
            style "gui_prompt"
            xalign 0.5
        hbox:
            xalign 0.5
            spacing 100
            textbutton _(ok_text) action ok_action

screen yes_no():
    modal True
    zorder 400
    add "gui/overlay/confirm.png"
    frame:
        background Frame([ "gui/confirm_frame.png", "gui/frame.png"], gui.confirm_frame_borders, tile=gui.frame_tile)
        padding gui.confirm_frame_borders.padding
        xalign .5
        yalign .5
        xmaximum 960
        has vbox:
            xalign .5
            yalign .5
            spacing 30
        text _("{font=Amoreiza Bold.ttf}{size=+10}Do you want to save your files in the modification folders?{/size}{/font}"):
            style "gui_prompt"
        text _("The following folders are saved:"):
            style "gui_prompt"

        side ("c r"):
            viewport id "mods_warn":
                draggable True
                mousewheel True
                ymaximum 400
                vbox:
                    for mod, value in save_mod_dir.items():
                        if persistent.mod_updater["TOGGLE_MODS"][mod]:
                            for path in value:
                                text _("    %s%s/%s%s" % ("{font=Amoreiza.ttf}", mod, path, "{/font}")):
                                    style "gui_prompt"
                        
            vbar value YScrollValue("mods_warn") top_bar Solid("#000000ff") bottom_bar Solid("#000000ff") thumb Solid("#FF2B95")   
        text _("Everything else will be completely {b}overwritten (deleted) when you upgrade{/b}, be careful not to lose anything!"):
            style "gui_prompt"
        hbox:
            xalign 0.5
            spacing 100
            # if no_action:
            textbutton _("No") action [SetDict(persistent.mod_updater, "DELETE", True), Hide("yes_no"), Hide("mod_news"), Function(md.thread)]
            textbutton _("I didn't have time to save it!") action Hide("yes_no")
            textbutton _("Yes") action [SetDict(persistent.mod_updater, "DELETE", False), Hide("yes_no"), Hide("mod_news"), Function(md.thread)]

init offset = 200

screen preferences():
    tag menu
    use game_menu(_("Preferences"), scroll="viewport"):
        vbox:
            hbox:
                box_wrap True
                if renpy.variant("pc") or renpy.variant("web"):
                    vbox:
                        style_prefix "radio"
                        label _("Display")
                        textbutton _("Window") action Preference("display", "window")
                        textbutton _("Fullscreen") action Preference("display", "fullscreen")
                vbox:
                    style_prefix "radio"
                    label _("Rollback Side")
                    textbutton _("Disable") action Preference("rollback side", "disable")
                    textbutton _("Left") action Preference("rollback side", "left")
                    textbutton _("Right") action Preference("rollback side", "right")
                vbox:
                    style_prefix "check"
                    label _("Skip")
                    textbutton _("Unseen Text") action Preference("skip", "toggle")
                    textbutton _("After Choices") action Preference("after choices", "toggle")
                vbox:
                    style_prefix "check"
                    label _("Discord")
                    textbutton _("Enabled") action ToggleVariable("persistent.discord_rpc_on")
                    textbutton _("Show label") action ToggleVariable("persistent.discord_rpc_label_on")
                    textbutton _("Show the dialog") action ToggleVariable("persistent.discord_rpc_say_on")
            null height (4 * gui.pref_spacing)
            hbox:
                style_prefix "slider"
                box_wrap True
                vbox:
                    label _("Text Speed")
                    bar value Preference("text speed")
                    label _("Auto Forward Time")
                    bar value Preference("auto-forward time")
                vbox:
                    if config.has_music:
                        label _("Music Volume")
                        hbox:
                            bar value Preference("music volume")
                    if config.has_sound:
                        label _("Sound Volume")
                        hbox:
                            bar value Preference("sound volume")
                            if config.sample_sound:
                                textbutton _("Test") action Play("sound", config.sample_sound)
                    if config.has_voice:
                        label _("Voice Volume")
                        hbox:
                            bar value Preference("voice volume")
                            if config.sample_voice:
                                textbutton _("Test") action Play("voice", config.sample_voice)
                    if config.has_music or config.has_sound or config.has_voice:
                        null height gui.pref_spacing
                        textbutton _("Mute All"):
                            action Preference("all mute", "toggle")
                            style "mute_all_button"
        if main_menu:
            textbutton _("Update modifications"):
                align (0.0, 0.0)
                action [md.CheckMods()]

define gui.page_spacing = -15
screen file_slots(title):
    default page_name_value = FilePageNameInputValue(pattern=_("Page {}"), auto=_("Automatic saves"), quick=_("Quick saves"))
    use game_menu(title):
        fixed:
            order_reverse True
            button:
                style "page_label"
                key_events True
                xalign 0.5
                action page_name_value.Toggle()
                input:
                    style "page_label_text"
                    value page_name_value
            hbox:
                xalign 0.5
                yalign 0.08
                if title == "Save":
                    text "Click on a page to rename it. Right click a save slot to OVERWRITE IT with a new name" style "gui_text"
            grid gui.file_slot_cols gui.file_slot_rows:
                style_prefix "slot"
                xalign 0.5
                yalign 0.5
                spacing gui.slot_spacing
                for i in range(gui.file_slot_cols * gui.file_slot_rows):
                    $ slot = i + 1
                    button:
                        action SetVariable("save_name", FileSaveName(slot)), FileAction(slot)
                        if title == "Save":
                            alternate Show("save_rename", slot=slot)
                        has vbox
                        add FileScreenshot(slot) xalign 0.5
                        text FileTime(slot, format=_("{#file_time}%A, %B %d %Y, %H:%M"), empty=_("empty slot")):
                            style "slot_time_text"
                        text FileSaveName(slot):
                            style "slot_name_text"
                        key "save_delete" action FileDelete(slot)
            hbox:
                xalign 0.5
                yalign 0.925
                if config.has_autosave:
                    textbutton _("{#auto_page}Auto Saves") action FilePage("auto")
                if config.has_quicksave:
                    textbutton _("{#quick_page}Quick Saves") action FilePage("quick")
            hbox:
                style_prefix "page"
                xalign 0.5
                yalign 0.975
                spacing gui.page_spacing
                if FilePageName() != u'a' and FilePageName() != u'q' and int(FilePageName()) > 1:
                    textbutton _("<<") action FilePage(max(int(FilePageName())-10,1)) alternate FilePage(1)
                else:
                    textbutton _("<<") action NullAction()
                textbutton _("<") action FilePagePrevious()
            hbox:
                style_prefix "page"
                xalign 0.5
                yalign 1.025
                spacing gui.page_spacing
                if FilePageName() != u'a' and FilePageName() != u'q' and int(FilePageName()) > 1:
                    for page in range(max(int(FilePageName())-9, 1), max(int(FilePageName())+11, 21)):
                        textbutton "[page]" action FilePage(page)
                else:
                    for page in range(1,21):
                        textbutton "[page]" action FilePage(page)
            hbox:
                style_prefix "page"
                xalign 0.5
                yalign 1.075
                spacing gui.page_spacing
                textbutton _(">") action FilePageNext()
                if FilePageName() != u'a' and FilePageName() != u'q':
                    textbutton _(">>") action FilePage(int(FilePageName())+10) alternate FilePage(int(FilePageName())+100)
                else:
                    textbutton _(">>") action NullAction()

screen quick_menu():
    zorder 100
    if quick_menu:
        hbox:
            style_prefix "quick"
            xalign 0.5
            yalign 1.0
            textbutton _("History") action ShowMenu('history')
            textbutton _("Skip") action Skip() alternate Skip(fast=True, confirm=True)
            textbutton _("Auto") action Preference("auto-forward", "toggle")
            textbutton _("Event Tracker") action ShowMenu('eventtracker11')
            textbutton _("Girls") action ShowMenu('eventtrackercharahub')
            textbutton _("Progress") action ShowMenu('affection')
            textbutton _("Unlockables") action ShowMenu('unlockables')
            textbutton _("Save") action ShowMenu('save')
            textbutton _("Load") action ShowMenu('load')
            textbutton _("Q.Save") action QuickSave()
            textbutton _("Q.Load") action QuickLoad()
            textbutton _("Prefs") action ShowMenu('preferences')
            textbutton _("Mod Menu") action ShowMenu('modmenu')

screen quick_menu():
    variant "touch"
    zorder 100
    if quick_menu:
        hbox:
            style_prefix "quick"
            xalign 0.5
            yalign 1.0
            textbutton _("Back") action Rollback()
            textbutton _("Skip") action Skip() alternate Skip(fast=True, confirm=True)
            textbutton _("Auto") action Preference("auto-forward", "toggle")
            textbutton _("Menu") action ShowMenu()
            textbutton _("Events") action ShowMenu('eventtracker11')
            textbutton _("Girls") action ShowMenu('eventtrackercharahub')
            textbutton _("Progress") action ShowMenu('affection')
            textbutton _("Unlockables") action ShowMenu('unlockables')
            if bonus == True:
                textbutton _("Wiki") action OpenURL("https://lessonsinlove.wiki/")
            textbutton _("Mod Menu") action ShowMenu('modmenu')
            textbutton _("Hide") action HideInterface()

screen modmenunavigation(title):
    style_prefix "game_menu"
    vbox:
        style_prefix "navigation"
        xpos gui.navigation_xpos
        yalign 0.5
        spacing gui.navigation_spacing
        if mhb == True:
            if day150 == True:
                textbutton _("Molly's Healing Button") action ShowMenu("MHB")
            else:
                textbutton _("{s}Irish girl not found{/s}")
        if lovelustchanger == True:
            textbutton _("Change points menu") action ShowMenu("lovelustchanger")
        if helper == True:
            textbutton _("Passage assistance") action ShowMenu("helper")
        if packmod == True:
            textbutton _("Pack Menu") action ShowMenu("packmenu")
        if customizationmod == True:
            textbutton _("Changing Character Icons") action ShowMenu("icon_setter")
    textbutton _("Return"):
        xpos 60
        ypos 900
        action [Return()]
    label title
    add "gametime" xpos 254

screen menu_mod(title, scroll=None, yinitial=0.0):
    style_prefix "game_menu"
    frame:
        style "game_menu_outer_frame"
        hbox:
            frame:
                style "game_menu_navigation_frame"
            frame:
                style "game_menu_content_frame"
                if scroll == "viewport":
                    viewport:
                        yinitial yinitial
                        scrollbars "vertical"
                        mousewheel True
                        draggable True
                        pagekeys True
                        side_yfill True
                        vbox:
                            transclude
                elif scroll == "vpgrid":
                    vpgrid:
                        cols 1
                        yinitial yinitial
                        scrollbars "vertical"
                        mousewheel True
                        draggable True
                        pagekeys True
                        side_yfill True
                        transclude
                else:
                    transclude
    label title
    use modmenunavigation(title="")

screen modmenu():
    tag menu
    add define_mods_images["mod_menu"]
    use menu_mod(_("Modifications Menu"), scroll="viewport")

screen download_screen(ok_action=[If(renpy.android, false=Function(renpy.reload_script), true=Function(renpy.quit)), Hide("download_screen")]):
    modal True
    zorder 200
    add "gui/overlay/confirm.png"
    default status = {
        "START":"Start",
        "DOWNLOADING":"Mod is downloaded from the server",
        "DELETING":"Old files are being deleted",
        "EXTRACTING":"Unpacking the archive is in progress",
        "SAVE_FILES":"Transferring your files",
        "FINISH":"Done! Looks like everything installed successfully!\n \"Close\" > Restart game",
        "NONE":"There seems to be nothing, how did you achieve that?",
        "ANDROID": "Looks like you installed the mod on android\n{b}EXPERIMENTAL SUPPORT{/b}",
        "VERSION_ERROR": "No modification version found for your version",
        "ERROR": "I'm sorry, there seems to be an unrecognized error"
    }
    frame:
        background Frame([ "gui/confirm_frame.png", "gui/frame.png"], gui.confirm_frame_borders, tile=gui.frame_tile)
        padding gui.confirm_frame_borders.padding
        xalign .5
        yalign .5
        xmaximum 700
        has vbox:
            xalign .5
            yalign .5
            spacing 30
        label _(persistent.mod_updater["DOWNLOADING_MOD"]):
            style "gui_prompt"
        label _(status[persistent.mod_updater.get("STATUS", "NONE")]):
            style "gui_prompt"
        bar value (persistent.mod_updater["PROGRESS"]) range 100
        text _(persistent.mod_updater["LENGH"])
        hbox:
            xalign 0.5
            spacing 100
            textbutton _("Close") action ok_action
    
    timer 0.1 action Function(renpy.restart_interaction) repeat True

screen mod_news():
    modal True
    zorder 200
    add "gui/overlay/confirm.png"
    default versions = {
        "VERSION_ERROR": "{color=ff0000}Not available for your version{/color}",
        "NEW": "{color=000000}Latest version{/color}",
        "OLD": "{color=008000}Update available{/color}",
        "NOT_INSTALLED": "{color=808080}The mod is not installed{/color}",
        "UNCORRECT": "{color=ff0000}Couldn't get a version{/color}"
    }
    frame:
        background Frame([ "gui/confirm_frame.png", "gui/frame.png"], gui.confirm_frame_borders, tile=gui.frame_tile)
        padding gui.confirm_frame_borders.padding
        xalign .5
        yalign .5
        has fixed:
            xysize (960, 700)
            # xalign .5
            # yalign .5
        vbox:
            
            text _("Mods"):
                yalign 0.0
                style "gui_text"
                size 80
            side ("c b"):
                side ("c r"):
                    viewport id "mods_scroller":
                        draggable True
                        mousewheel True

                        hbox:
                            xfill True
                            vbox:
                                spacing 0
                                for mod in persistent.mod_updater["MODS"]:
                                    hbox:
                                        ysize 65
                                        textbutton _(mod):
                                            text_size 40
                                            yalign .5
                                            action SelectMod(mod)     
                                            alternate Show("mod_description", mod=mod)                                     
                            vbox:
                                spacing 0
                                for mod in persistent.mod_updater["MODS"]:
                                    hbox:
                                        ysize 65
                                        text _(versions[persistent.mod_updater["INSTALLED_MODS"][mod]]):
                                            size 40
                                            yalign .5                                   
                    vbar value YScrollValue("mods_scroller") top_bar Solid("#000000ff") bottom_bar Solid("#000000ff") thumb Solid("#FF2B95")                        
                hbox:
                    xfill True
                    yalign 1.0
                    spacing 600
                    textbutton _("Cancel"):
                        text_size 50
                        action Hide("mod_news")
                    textbutton _("Download"):
                        text_size 50
                        action md.StartInstall()

screen mod_description(mod):
    zorder 300
    frame:
        background Frame([ "gui/confirm_frame.png", "gui/frame.png"], gui.confirm_frame_borders, tile=gui.frame_tile)
        padding gui.confirm_frame_borders.padding
        xalign .5
        yalign .5
        has fixed:
            xysize (960, 700)
        vbox:
            
            text _("Description"):
                yalign 0.0
                style "gui_text"
                size 80
            side ("c b"):
                side ("c r"):
                    viewport id "description_scroller":
                        draggable True
                        mousewheel True
                        text _(persistent.mod_updater["MODS"][mod]["description"])
                    vbar value YScrollValue("description_scroller") top_bar Solid("#000000ff") bottom_bar Solid("#000000ff") thumb Solid("#FF2B95")
                textbutton _("Close"):
                    text_size 50
                    action Hide("mod_description")
